use std::path::PathBuf;

use super::{Loadable, Relocatable};
use crate::error::Error;

pub trait Output<R>
where
    R: Relocatable,
{
    fn relocate_sections(&mut self, objects: &[R], loadable: &mut Loadable) -> Result<(), Error>;

    fn resolve_symbols(&mut self, objects: &[R], loadable: &mut Loadable) -> Result<(), Error>;

    fn finalize(self) -> Result<PathBuf, Error>;
}
